/* image.c generated by valac 0.22.1, the Vala compiler
 * generated from image.vala, do not modify */

/* Copyright 2009-2013 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>


#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;

#define TYPE_RGB_TRANSFORMATION (rgb_transformation_get_type ())
#define RGB_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RGB_TRANSFORMATION, RGBTransformation))
#define RGB_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RGB_TRANSFORMATION, RGBTransformationClass))
#define IS_RGB_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RGB_TRANSFORMATION))
#define IS_RGB_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RGB_TRANSFORMATION))
#define RGB_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RGB_TRANSFORMATION, RGBTransformationClass))

typedef struct _RGBTransformation RGBTransformation;
typedef struct _RGBTransformationClass RGBTransformationClass;

#define TYPE_SATURATION_TRANSFORMATION (saturation_transformation_get_type ())
#define SATURATION_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SATURATION_TRANSFORMATION, SaturationTransformation))
#define SATURATION_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SATURATION_TRANSFORMATION, SaturationTransformationClass))
#define IS_SATURATION_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SATURATION_TRANSFORMATION))
#define IS_SATURATION_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SATURATION_TRANSFORMATION))
#define SATURATION_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SATURATION_TRANSFORMATION, SaturationTransformationClass))

typedef struct _SaturationTransformation SaturationTransformation;
typedef struct _SaturationTransformationClass SaturationTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Dimensions {
	gint width;
	gint height;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};



gboolean is_color_parsable (const gchar* spec);
void parse_color (const gchar* spec, GdkRGBA* result);
void fetch_color (const gchar* spec, GdkRGBA* result);
void set_source_color_from_string (cairo_t* ctx, const gchar* spec);
#define MIN_SCALED_WIDTH 10
#define MIN_SCALED_HEIGHT 10
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
#define DEGREE (G_PI / 180.0)
void draw_rounded_corners_filled (cairo_t* ctx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion);
void context_rounded_corners (cairo_t* cx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion);
gint dimensions_minor_axis (Dimensions *self);
guchar shift_color_byte (gint b, gint shift);
void shift_colors (GdkPixbuf* pixbuf, gint red, gint green, gint blue, gint alpha);
void dim_pixbuf (GdkPixbuf* pixbuf);
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
PixelTransformer* pixel_transformer_new (void);
PixelTransformer* pixel_transformer_construct (GType object_type);
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
GType rgb_transformation_get_type (void) G_GNUC_CONST;
GType saturation_transformation_get_type (void) G_GNUC_CONST;
#define SATURATION_TRANSFORMATION_MIN_PARAMETER (-16.0f)
SaturationTransformation* saturation_transformation_new (gfloat client_parameter);
SaturationTransformation* saturation_transformation_construct (GType object_type, gfloat client_parameter);
void pixel_transformer_attach_transformation (PixelTransformer* self, PixelTransformation* trans);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean coord_in_rectangle (gint x, gint y, GdkRectangle* rect);
gboolean rectangles_equal (GdkRectangle* a, GdkRectangle* b);
gchar* rectangle_to_string (GdkRectangle* rect);
void clamp_rectangle (GdkRectangle* original, Dimensions* max, GdkRectangle* result);
void scale_point (GdkPoint* p, gdouble factor, GdkPoint* result);
void add_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result);
void subtract_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result);
void fix_cairo_pixbuf (GdkPixbuf* pixbuf);
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height);
gdouble degrees_to_radians (gdouble theta);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle);
void rotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, gboolean invert, GdkPoint* result);
void derotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, GdkPoint* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
void clamp_inside_rotated_image (Box* src, gint img_w, gint img_h, gdouble angle_deg, gboolean preserve_geom, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);


gboolean is_color_parsable (const gchar* spec) {
	gboolean result = FALSE;
	GdkColor color = {0};
	const gchar* _tmp0_ = NULL;
	GdkColor _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
#line 7 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (spec != NULL, FALSE);
#line 9 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = spec;
#line 9 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = gdk_color_parse (_tmp0_, &_tmp1_);
#line 9 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	color = _tmp1_;
#line 9 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = _tmp2_;
#line 9 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 172 "image.c"
}


void parse_color (const gchar* spec, GdkRGBA* result) {
	const gchar* _tmp0_ = NULL;
	GdkRGBA _tmp1_ = {0};
#line 12 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 13 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = spec;
#line 13 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	fetch_color (_tmp0_, &_tmp1_);
#line 13 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _tmp1_;
#line 13 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 189 "image.c"
}


void fetch_color (const gchar* spec, GdkRGBA* result) {
	GdkRGBA rgba = {0};
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 16 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 17 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	memset (&rgba, 0, sizeof (GdkRGBA));
#line 18 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = spec;
#line 18 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = gdk_rgba_parse (&rgba, _tmp0_);
#line 18 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (!_tmp1_) {
#line 207 "image.c"
		const gchar* _tmp2_ = NULL;
#line 19 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = spec;
#line 19 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		g_error ("image.vala:19: Can't parse color %s", _tmp2_);
#line 213 "image.c"
	}
#line 21 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = rgba;
#line 21 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 219 "image.c"
}


void set_source_color_from_string (cairo_t* ctx, const gchar* spec) {
	GdkRGBA rgba = {0};
	const gchar* _tmp0_ = NULL;
	GdkRGBA _tmp1_ = {0};
	cairo_t* _tmp2_ = NULL;
	GdkRGBA _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	GdkRGBA _tmp5_ = {0};
	gdouble _tmp6_ = 0.0;
	GdkRGBA _tmp7_ = {0};
	gdouble _tmp8_ = 0.0;
	GdkRGBA _tmp9_ = {0};
	gdouble _tmp10_ = 0.0;
#line 24 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (ctx != NULL);
#line 24 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (spec != NULL);
#line 25 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = spec;
#line 25 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	fetch_color (_tmp0_, &_tmp1_);
#line 25 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rgba = _tmp1_;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = ctx;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = rgba;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = _tmp3_.red;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = rgba;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.green;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = rgba;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = _tmp7_.blue;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = rgba;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp10_ = _tmp9_.alpha;
#line 26 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_set_source_rgba (_tmp2_, _tmp4_, _tmp6_, _tmp8_, _tmp10_);
#line 266 "image.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 36 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return self ? g_object_ref (self) : NULL;
#line 273 "image.c"
}


GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up) {
	GdkPixbuf* result = NULL;
	Dimensions original = {0};
	GdkPixbuf* _tmp0_ = NULL;
	Dimensions _tmp1_ = {0};
	Dimensions scaled = {0};
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	Dimensions _tmp6_ = {0};
	gint _tmp7_ = 0;
	Dimensions _tmp8_ = {0};
	gint _tmp9_ = 0;
	gboolean _tmp14_ = FALSE;
	Dimensions _tmp17_ = {0};
	GdkPixbuf* _tmp18_ = NULL;
	Dimensions _tmp19_ = {0};
	gint _tmp20_ = 0;
	Dimensions _tmp21_ = {0};
	gint _tmp22_ = 0;
	GdkInterpType _tmp23_ = 0;
	GdkPixbuf* _tmp24_ = NULL;
#line 32 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 33 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = pixbuf;
#line 33 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dimensions_for_pixbuf (_tmp0_, &_tmp1_);
#line 33 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	original = _tmp1_;
#line 34 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = scale;
#line 34 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = scale_up;
#line 34 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dimensions_get_scaled (&original, _tmp2_, _tmp3_, &_tmp4_);
#line 34 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	scaled = _tmp4_;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = original;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = _tmp6_.width;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = scaled;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = _tmp8_.width;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp7_ == _tmp9_) {
#line 326 "image.c"
		Dimensions _tmp10_ = {0};
		gint _tmp11_ = 0;
		Dimensions _tmp12_ = {0};
		gint _tmp13_ = 0;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp10_ = original;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp11_ = _tmp10_.height;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp12_ = scaled;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp13_ = _tmp12_.height;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp5_ = _tmp11_ == _tmp13_;
#line 341 "image.c"
	} else {
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp5_ = FALSE;
#line 345 "image.c"
	}
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp14_ = _tmp5_;
#line 35 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp14_) {
#line 351 "image.c"
		GdkPixbuf* _tmp15_ = NULL;
		GdkPixbuf* _tmp16_ = NULL;
#line 36 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp15_ = pixbuf;
#line 36 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 36 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		result = _tmp16_;
#line 36 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		return result;
#line 362 "image.c"
	}
#line 39 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dimensions_with_min (&scaled, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp17_);
#line 39 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	scaled = _tmp17_;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = pixbuf;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = scaled;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = _tmp19_.width;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = scaled;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp22_ = _tmp21_.height;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp23_ = interp;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp24_ = gdk_pixbuf_scale_simple (_tmp18_, _tmp20_, _tmp22_, _tmp23_);
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = _tmp24_;
#line 41 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 386 "image.c"
}


GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp) {
	GdkPixbuf* result = NULL;
	Dimensions original = {0};
	GdkPixbuf* _tmp0_ = NULL;
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_ = {0};
	gint _tmp4_ = 0;
	Dimensions _tmp5_ = {0};
	gint _tmp6_ = 0;
	gboolean _tmp11_ = FALSE;
	Dimensions _tmp14_ = {0};
	GdkPixbuf* _tmp15_ = NULL;
	Dimensions _tmp16_ = {0};
	gint _tmp17_ = 0;
	Dimensions _tmp18_ = {0};
	gint _tmp19_ = 0;
	GdkInterpType _tmp20_ = 0;
	GdkPixbuf* _tmp21_ = NULL;
#line 44 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 44 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (resized != NULL, NULL);
#line 45 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = pixbuf;
#line 45 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dimensions_for_pixbuf (_tmp0_, &_tmp1_);
#line 45 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	original = _tmp1_;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = original;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = _tmp3_.width;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = *resized;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.width;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp4_ == _tmp6_) {
#line 429 "image.c"
		Dimensions _tmp7_ = {0};
		gint _tmp8_ = 0;
		Dimensions _tmp9_ = {0};
		gint _tmp10_ = 0;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp7_ = original;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp8_ = _tmp7_.height;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp9_ = *resized;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp10_ = _tmp9_.height;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = _tmp8_ == _tmp10_;
#line 444 "image.c"
	} else {
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = FALSE;
#line 448 "image.c"
	}
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = _tmp2_;
#line 46 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp11_) {
#line 454 "image.c"
		GdkPixbuf* _tmp12_ = NULL;
		GdkPixbuf* _tmp13_ = NULL;
#line 47 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp12_ = pixbuf;
#line 47 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 47 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		result = _tmp13_;
#line 47 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		return result;
#line 465 "image.c"
	}
#line 50 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dimensions_with_min (resized, MIN_SCALED_WIDTH, MIN_SCALED_HEIGHT, &_tmp14_);
#line 50 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*resized = _tmp14_;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = pixbuf;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = *resized;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp17_ = _tmp16_.width;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = *resized;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = _tmp18_.height;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = interp;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = gdk_pixbuf_scale_simple (_tmp15_, _tmp17_, _tmp19_, _tmp20_);
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = _tmp21_;
#line 52 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 489 "image.c"
}


void draw_rounded_corners_filled (cairo_t* ctx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion) {
	cairo_t* _tmp0_ = NULL;
	Dimensions _tmp1_ = {0};
	GdkPoint _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	cairo_t* _tmp4_ = NULL;
#line 57 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (ctx != NULL);
#line 57 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (dim != NULL);
#line 57 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (origin != NULL);
#line 59 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = ctx;
#line 59 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = *dim;
#line 59 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = *origin;
#line 59 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = radius_proportion;
#line 59 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	context_rounded_corners (_tmp0_, &_tmp1_, &_tmp2_, _tmp3_);
#line 60 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = ctx;
#line 60 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_paint (_tmp4_);
#line 519 "image.c"
}


void context_rounded_corners (cairo_t* cx, Dimensions* dim, GdkPoint* origin, gdouble radius_proportion) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble left = 0.0;
	GdkPoint _tmp2_ = {0};
	gint _tmp3_ = 0;
	gdouble top = 0.0;
	GdkPoint _tmp4_ = {0};
	gint _tmp5_ = 0;
	gdouble right = 0.0;
	GdkPoint _tmp6_ = {0};
	gint _tmp7_ = 0;
	Dimensions _tmp8_ = {0};
	gint _tmp9_ = 0;
	gdouble bottom = 0.0;
	GdkPoint _tmp10_ = {0};
	gint _tmp11_ = 0;
	Dimensions _tmp12_ = {0};
	gint _tmp13_ = 0;
	gdouble radius = 0.0;
	gint _tmp14_ = 0;
	gdouble _tmp15_ = 0.0;
	cairo_t* _tmp16_ = NULL;
	cairo_t* _tmp17_ = NULL;
	cairo_t* _tmp18_ = NULL;
	cairo_t* _tmp19_ = NULL;
	cairo_t* _tmp20_ = NULL;
	cairo_t* _tmp21_ = NULL;
#line 63 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (cx != NULL);
#line 63 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (dim != NULL);
#line 63 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (origin != NULL);
#line 66 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = radius_proportion;
#line 66 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = CLAMP (_tmp0_, 2.0, 100.0);
#line 66 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	radius_proportion = _tmp1_;
#line 68 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = *origin;
#line 68 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = _tmp2_.x;
#line 68 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	left = (gdouble) _tmp3_;
#line 69 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = *origin;
#line 69 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = _tmp4_.y;
#line 69 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	top = (gdouble) _tmp5_;
#line 70 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = *origin;
#line 70 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = _tmp6_.x;
#line 70 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = *dim;
#line 70 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = _tmp8_.width;
#line 70 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	right = (gdouble) (_tmp7_ + _tmp9_);
#line 71 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp10_ = *origin;
#line 71 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = _tmp10_.y;
#line 71 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp12_ = *dim;
#line 71 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_ = _tmp12_.height;
#line 71 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	bottom = (gdouble) (_tmp11_ + _tmp13_);
#line 74 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp14_ = dimensions_minor_axis (dim);
#line 74 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = radius_proportion;
#line 74 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	radius = ((gdouble) _tmp14_) / _tmp15_;
#line 78 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = cx;
#line 78 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_move_to (_tmp16_, left, top);
#line 79 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp17_ = cx;
#line 79 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_arc (_tmp17_, right - radius, top + radius, radius, (-90) * DEGREE, 0 * DEGREE);
#line 80 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = cx;
#line 80 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_arc (_tmp18_, right - radius, bottom - radius, radius, 0 * DEGREE, 90 * DEGREE);
#line 81 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = cx;
#line 81 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_arc (_tmp19_, left + radius, bottom - radius, radius, 90 * DEGREE, 180 * DEGREE);
#line 82 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = cx;
#line 82 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_arc (_tmp20_, left + radius, top + radius, radius, 180 * DEGREE, 270 * DEGREE);
#line 83 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = cx;
#line 83 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_clip (_tmp21_);
#line 625 "image.c"
}


inline guchar shift_color_byte (gint b, gint shift) {
	guchar result = '\0';
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 87 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = b;
#line 87 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = shift;
#line 87 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = CLAMP (_tmp0_ + _tmp1_, 0, 255);
#line 87 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = (guchar) _tmp2_;
#line 87 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 644 "image.c"
}


void shift_colors (GdkPixbuf* pixbuf, gint red, gint green, gint blue, gint alpha) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_ = 0;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_ = 0;
	gboolean _tmp15_ = FALSE;
	gint width = 0;
	GdkPixbuf* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint height = 0;
	GdkPixbuf* _tmp18_ = NULL;
	gint _tmp19_ = 0;
	gint rowstride = 0;
	GdkPixbuf* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	gint channels = 0;
	GdkPixbuf* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	guchar* pixels = NULL;
	GdkPixbuf* _tmp24_ = NULL;
	guint8* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	GdkPixbuf* _tmp27_ = NULL;
	GdkColorspace _tmp28_ = 0;
	GdkPixbuf* _tmp29_ = NULL;
	gint _tmp30_ = 0;
#line 90 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = red;
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp1_ >= (-255)) {
#line 687 "image.c"
		gint _tmp2_ = 0;
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = red;
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp0_ = _tmp2_ <= 255;
#line 693 "image.c"
	} else {
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp0_ = FALSE;
#line 697 "image.c"
	}
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = _tmp0_;
#line 91 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp3_, "red >= -255 && red <= 255");
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = green;
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp5_ >= (-255)) {
#line 707 "image.c"
		gint _tmp6_ = 0;
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp6_ = green;
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp4_ = _tmp6_ <= 255;
#line 713 "image.c"
	} else {
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp4_ = FALSE;
#line 717 "image.c"
	}
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = _tmp4_;
#line 92 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp7_, "green >= -255 && green <= 255");
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = blue;
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp9_ >= (-255)) {
#line 727 "image.c"
		gint _tmp10_ = 0;
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp10_ = blue;
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp8_ = _tmp10_ <= 255;
#line 733 "image.c"
	} else {
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp8_ = FALSE;
#line 737 "image.c"
	}
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = _tmp8_;
#line 93 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp11_, "blue >= -255 && blue <= 255");
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_ = alpha;
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp13_ >= (-255)) {
#line 747 "image.c"
		gint _tmp14_ = 0;
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp14_ = alpha;
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp12_ = _tmp14_ <= 255;
#line 753 "image.c"
	} else {
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp12_ = FALSE;
#line 757 "image.c"
	}
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = _tmp12_;
#line 94 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp15_, "alpha >= -255 && alpha <= 255");
#line 96 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = pixbuf;
#line 96 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp17_ = gdk_pixbuf_get_width (_tmp16_);
#line 96 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	width = _tmp17_;
#line 97 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = pixbuf;
#line 97 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = gdk_pixbuf_get_height (_tmp18_);
#line 97 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	height = _tmp19_;
#line 98 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = pixbuf;
#line 98 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = gdk_pixbuf_get_rowstride (_tmp20_);
#line 98 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rowstride = _tmp21_;
#line 99 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp22_ = pixbuf;
#line 99 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp23_ = gdk_pixbuf_get_n_channels (_tmp22_);
#line 99 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	channels = _tmp23_;
#line 100 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp24_ = pixbuf;
#line 100 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp25_ = gdk_pixbuf_get_pixels (_tmp24_);
#line 100 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	pixels = _tmp25_;
#line 102 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp26_ = channels;
#line 102 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp26_ >= 3, "channels >= 3");
#line 103 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp27_ = pixbuf;
#line 103 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp28_ = gdk_pixbuf_get_colorspace (_tmp27_);
#line 103 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp28_ == GDK_COLORSPACE_RGB, "pixbuf.get_colorspace() == Gdk.Colorspace.RGB");
#line 104 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp29_ = pixbuf;
#line 104 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp30_ = gdk_pixbuf_get_bits_per_sample (_tmp29_);
#line 104 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp30_ == 8, "pixbuf.get_bits_per_sample() == 8");
#line 809 "image.c"
	{
		gint y = 0;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		y = 0;
#line 814 "image.c"
		{
			gboolean _tmp31_ = FALSE;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
			_tmp31_ = TRUE;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
			while (TRUE) {
#line 821 "image.c"
				gboolean _tmp32_ = FALSE;
				gint _tmp34_ = 0;
				gint _tmp35_ = 0;
				gint y_offset = 0;
				gint _tmp36_ = 0;
				gint _tmp37_ = 0;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp32_ = _tmp31_;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				if (!_tmp32_) {
#line 832 "image.c"
					gint _tmp33_ = 0;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp33_ = y;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					y = _tmp33_ + 1;
#line 838 "image.c"
				}
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp31_ = FALSE;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp34_ = y;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp35_ = height;
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				if (!(_tmp34_ < _tmp35_)) {
#line 106 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					break;
#line 850 "image.c"
				}
#line 107 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp36_ = y;
#line 107 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp37_ = rowstride;
#line 107 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				y_offset = _tmp36_ * _tmp37_;
#line 858 "image.c"
				{
					gint x = 0;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					x = 0;
#line 863 "image.c"
					{
						gboolean _tmp38_ = FALSE;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
						_tmp38_ = TRUE;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
						while (TRUE) {
#line 870 "image.c"
							gboolean _tmp39_ = FALSE;
							gint _tmp41_ = 0;
							gint _tmp42_ = 0;
							gint offset = 0;
							gint _tmp43_ = 0;
							gint _tmp44_ = 0;
							gint _tmp45_ = 0;
							gint _tmp46_ = 0;
							gint _tmp55_ = 0;
							gint _tmp64_ = 0;
							gboolean _tmp73_ = FALSE;
							gint _tmp74_ = 0;
							gboolean _tmp76_ = FALSE;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp39_ = _tmp38_;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (!_tmp39_) {
#line 888 "image.c"
								gint _tmp40_ = 0;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp40_ = x;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								x = _tmp40_ + 1;
#line 894 "image.c"
							}
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp38_ = FALSE;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp41_ = x;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp42_ = width;
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (!(_tmp41_ < _tmp42_)) {
#line 109 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								break;
#line 906 "image.c"
							}
#line 110 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp43_ = y_offset;
#line 110 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp44_ = x;
#line 110 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp45_ = channels;
#line 110 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							offset = _tmp43_ + (_tmp44_ * _tmp45_);
#line 112 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp46_ = red;
#line 112 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (_tmp46_ != 0) {
#line 920 "image.c"
								guchar* _tmp47_ = NULL;
								gint _tmp48_ = 0;
								guchar* _tmp49_ = NULL;
								gint _tmp50_ = 0;
								guchar _tmp51_ = '\0';
								gint _tmp52_ = 0;
								guchar _tmp53_ = '\0';
								guchar _tmp54_ = '\0';
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp47_ = pixels;
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp48_ = offset;
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp49_ = pixels;
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp50_ = offset;
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp51_ = _tmp49_[_tmp50_];
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp52_ = red;
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp53_ = shift_color_byte ((gint) _tmp51_, _tmp52_);
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp47_[_tmp48_] = _tmp53_;
#line 113 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp54_ = _tmp47_[_tmp48_];
#line 947 "image.c"
							}
#line 115 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp55_ = green;
#line 115 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (_tmp55_ != 0) {
#line 953 "image.c"
								guchar* _tmp56_ = NULL;
								gint _tmp57_ = 0;
								guchar* _tmp58_ = NULL;
								gint _tmp59_ = 0;
								guchar _tmp60_ = '\0';
								gint _tmp61_ = 0;
								guchar _tmp62_ = '\0';
								guchar _tmp63_ = '\0';
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp56_ = pixels;
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp57_ = offset;
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp58_ = pixels;
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp59_ = offset;
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp60_ = _tmp58_[_tmp59_ + 1];
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp61_ = green;
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp62_ = shift_color_byte ((gint) _tmp60_, _tmp61_);
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp56_[_tmp57_ + 1] = _tmp62_;
#line 116 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp63_ = _tmp56_[_tmp57_ + 1];
#line 980 "image.c"
							}
#line 118 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp64_ = blue;
#line 118 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (_tmp64_ != 0) {
#line 986 "image.c"
								guchar* _tmp65_ = NULL;
								gint _tmp66_ = 0;
								guchar* _tmp67_ = NULL;
								gint _tmp68_ = 0;
								guchar _tmp69_ = '\0';
								gint _tmp70_ = 0;
								guchar _tmp71_ = '\0';
								guchar _tmp72_ = '\0';
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp65_ = pixels;
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp66_ = offset;
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp67_ = pixels;
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp68_ = offset;
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp69_ = _tmp67_[_tmp68_ + 2];
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp70_ = blue;
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp71_ = shift_color_byte ((gint) _tmp69_, _tmp70_);
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp65_[_tmp66_ + 2] = _tmp71_;
#line 119 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp72_ = _tmp65_[_tmp66_ + 2];
#line 1013 "image.c"
							}
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp74_ = alpha;
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (_tmp74_ != 0) {
#line 1019 "image.c"
								gint _tmp75_ = 0;
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp75_ = channels;
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp73_ = _tmp75_ >= 4;
#line 1025 "image.c"
							} else {
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp73_ = FALSE;
#line 1029 "image.c"
							}
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							_tmp76_ = _tmp73_;
#line 121 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
							if (_tmp76_) {
#line 1035 "image.c"
								guchar* _tmp77_ = NULL;
								gint _tmp78_ = 0;
								guchar* _tmp79_ = NULL;
								gint _tmp80_ = 0;
								guchar _tmp81_ = '\0';
								gint _tmp82_ = 0;
								guchar _tmp83_ = '\0';
								guchar _tmp84_ = '\0';
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp77_ = pixels;
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp78_ = offset;
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp79_ = pixels;
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp80_ = offset;
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp81_ = _tmp79_[_tmp80_ + 3];
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp82_ = alpha;
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp83_ = shift_color_byte ((gint) _tmp81_, _tmp82_);
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp77_[_tmp78_ + 3] = _tmp83_;
#line 122 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
								_tmp84_ = _tmp77_[_tmp78_ + 3];
#line 1062 "image.c"
							}
						}
					}
				}
			}
		}
	}
}


void dim_pixbuf (GdkPixbuf* pixbuf) {
	PixelTransformer* transformer = NULL;
	PixelTransformer* _tmp0_ = NULL;
	SaturationTransformation* sat = NULL;
	SaturationTransformation* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
#line 127 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 128 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = pixel_transformer_new ();
#line 128 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	transformer = _tmp0_;
#line 129 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = saturation_transformation_new (SATURATION_TRANSFORMATION_MIN_PARAMETER);
#line 129 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	sat = _tmp1_;
#line 130 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	pixel_transformer_attach_transformation (transformer, G_TYPE_CHECK_INSTANCE_CAST (sat, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 131 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = pixbuf;
#line 131 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	pixel_transformer_transform_pixbuf (transformer, _tmp2_, NULL);
#line 132 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = pixbuf;
#line 132 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	shift_colors (_tmp3_, 0, 0, 0, -100);
#line 127 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_pixel_transformation_unref0 (sat);
#line 127 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_pixel_transformer_unref0 (transformer);
#line 1104 "image.c"
}


gboolean coord_in_rectangle (gint x, gint y, GdkRectangle* rect) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	GdkRectangle _tmp4_ = {0};
	gint _tmp5_ = 0;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp21_ = FALSE;
#line 135 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (rect != NULL, FALSE);
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = x;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = *rect;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = _tmp4_.x;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp3_ >= _tmp5_) {
#line 1129 "image.c"
		gint _tmp6_ = 0;
		GdkRectangle _tmp7_ = {0};
		gint _tmp8_ = 0;
		GdkRectangle _tmp9_ = {0};
		gint _tmp10_ = 0;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp6_ = x;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp7_ = *rect;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp8_ = _tmp7_.x;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp9_ = *rect;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp10_ = _tmp9_.width;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = _tmp6_ < (_tmp8_ + _tmp10_);
#line 1147 "image.c"
	} else {
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = FALSE;
#line 1151 "image.c"
	}
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = _tmp2_;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp11_) {
#line 1157 "image.c"
		gint _tmp12_ = 0;
		GdkRectangle _tmp13_ = {0};
		gint _tmp14_ = 0;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp12_ = y;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp13_ = *rect;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp14_ = _tmp13_.y;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp1_ = _tmp12_ >= _tmp14_;
#line 1169 "image.c"
	} else {
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp1_ = FALSE;
#line 1173 "image.c"
	}
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = _tmp1_;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp15_) {
#line 1179 "image.c"
		gint _tmp16_ = 0;
		GdkRectangle _tmp17_ = {0};
		gint _tmp18_ = 0;
		GdkRectangle _tmp19_ = {0};
		gint _tmp20_ = 0;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp16_ = y;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp17_ = *rect;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp18_ = _tmp17_.y;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp19_ = *rect;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp20_ = _tmp19_.height;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp0_ = _tmp16_ <= (_tmp18_ + _tmp20_);
#line 1197 "image.c"
	} else {
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp0_ = FALSE;
#line 1201 "image.c"
	}
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = _tmp0_;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = _tmp21_;
#line 136 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 1209 "image.c"
}


gboolean rectangles_equal (GdkRectangle* a, GdkRectangle* b) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_ = {0};
	gint _tmp4_ = 0;
	GdkRectangle _tmp5_ = {0};
	gint _tmp6_ = 0;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp21_ = FALSE;
#line 139 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 139 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = *a;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = _tmp3_.x;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = *b;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.x;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp4_ == _tmp6_) {
#line 1239 "image.c"
		GdkRectangle _tmp7_ = {0};
		gint _tmp8_ = 0;
		GdkRectangle _tmp9_ = {0};
		gint _tmp10_ = 0;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp7_ = *a;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp8_ = _tmp7_.y;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp9_ = *b;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp10_ = _tmp9_.y;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = _tmp8_ == _tmp10_;
#line 1254 "image.c"
	} else {
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = FALSE;
#line 1258 "image.c"
	}
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = _tmp2_;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp11_) {
#line 1264 "image.c"
		GdkRectangle _tmp12_ = {0};
		gint _tmp13_ = 0;
		GdkRectangle _tmp14_ = {0};
		gint _tmp15_ = 0;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp12_ = *a;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp13_ = _tmp12_.width;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp14_ = *b;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp15_ = _tmp14_.width;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp1_ = _tmp13_ == _tmp15_;
#line 1279 "image.c"
	} else {
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp1_ = FALSE;
#line 1283 "image.c"
	}
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = _tmp1_;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp16_) {
#line 1289 "image.c"
		GdkRectangle _tmp17_ = {0};
		gint _tmp18_ = 0;
		GdkRectangle _tmp19_ = {0};
		gint _tmp20_ = 0;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp17_ = *a;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp18_ = _tmp17_.height;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp19_ = *b;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp20_ = _tmp19_.height;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp0_ = _tmp18_ == _tmp20_;
#line 1304 "image.c"
	} else {
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp0_ = FALSE;
#line 1308 "image.c"
	}
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = _tmp0_;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = _tmp21_;
#line 140 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 1316 "image.c"
}


gchar* rectangle_to_string (GdkRectangle* rect) {
	gchar* result = NULL;
	GdkRectangle _tmp0_ = {0};
	gint _tmp1_ = 0;
	GdkRectangle _tmp2_ = {0};
	gint _tmp3_ = 0;
	GdkRectangle _tmp4_ = {0};
	gint _tmp5_ = 0;
	GdkRectangle _tmp6_ = {0};
	gint _tmp7_ = 0;
	gchar* _tmp8_ = NULL;
#line 143 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (rect != NULL, NULL);
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = *rect;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = _tmp0_.x;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = *rect;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = _tmp2_.y;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = *rect;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = _tmp4_.width;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = *rect;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = _tmp6_.height;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = g_strdup_printf ("%d,%d %dx%d", _tmp1_, _tmp3_, _tmp5_, _tmp7_);
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = _tmp8_;
#line 144 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 1355 "image.c"
}


void clamp_rectangle (GdkRectangle* original, Dimensions* max, GdkRectangle* result) {
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GdkRectangle _tmp5_ = {0};
	gint _tmp6_ = 0;
	Dimensions _tmp7_ = {0};
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	GdkRectangle _tmp10_ = {0};
	gint _tmp11_ = 0;
	Dimensions _tmp12_ = {0};
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	GdkRectangle _tmp15_ = {0};
	gint _tmp16_ = 0;
	Dimensions _tmp17_ = {0};
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
#line 147 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (original != NULL);
#line 147 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (max != NULL);
#line 148 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 149 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = *original;
#line 149 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = _tmp0_.x;
#line 149 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = *max;
#line 149 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = _tmp2_.width;
#line 149 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = CLAMP (_tmp1_, 0, _tmp3_);
#line 149 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rect.x = _tmp4_;
#line 150 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = *original;
#line 150 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 150 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = *max;
#line 150 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = _tmp7_.height;
#line 150 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = CLAMP (_tmp6_, 0, _tmp8_);
#line 150 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rect.y = _tmp9_;
#line 151 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp10_ = *original;
#line 151 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = _tmp10_.width;
#line 151 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp12_ = *max;
#line 151 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_ = _tmp12_.width;
#line 151 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp14_ = CLAMP (_tmp11_, 0, _tmp13_);
#line 151 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rect.width = _tmp14_;
#line 152 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = *original;
#line 152 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = _tmp15_.height;
#line 152 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp17_ = *max;
#line 152 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = _tmp17_.height;
#line 152 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = CLAMP (_tmp16_, 0, _tmp18_);
#line 152 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rect.height = _tmp19_;
#line 154 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = rect;
#line 154 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 1439 "image.c"
}


void scale_point (GdkPoint* p, gdouble factor, GdkPoint* result) {
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	gdouble _tmp1_ = 0.0;
	GdkPoint _tmp2_ = {0};
	gint _tmp3_ = 0;
	gdouble _tmp4_ = 0.0;
	GdkPoint _tmp5_ = {0};
	gint _tmp6_ = 0;
#line 157 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (p != NULL);
#line 158 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_.x = 0;
#line 158 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_ = _tmp0_;
#line 159 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = factor;
#line 159 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = *p;
#line 159 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = _tmp2_.x;
#line 159 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_.x = (gint) ((_tmp1_ * _tmp3_) + 0.5);
#line 160 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = factor;
#line 160 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = *p;
#line 160 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 160 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_.y = (gint) ((_tmp4_ * _tmp6_) + 0.5);
#line 162 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _result_;
#line 162 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 1478 "image.c"
}


void add_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result) {
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	gint _tmp2_ = 0;
	GdkPoint _tmp3_ = {0};
	gint _tmp4_ = 0;
	GdkPoint _tmp5_ = {0};
	gint _tmp6_ = 0;
	GdkPoint _tmp7_ = {0};
	gint _tmp8_ = 0;
#line 165 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (p1 != NULL);
#line 165 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (p2 != NULL);
#line 166 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_.x = 0;
#line 166 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_ = _tmp0_;
#line 167 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = *p1;
#line 167 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = _tmp1_.x;
#line 167 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = *p2;
#line 167 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = _tmp3_.x;
#line 167 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_.x = _tmp2_ + _tmp4_;
#line 168 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = *p1;
#line 168 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 168 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = *p2;
#line 168 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = _tmp7_.y;
#line 168 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_.y = _tmp6_ + _tmp8_;
#line 170 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _result_;
#line 170 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 1525 "image.c"
}


void subtract_points (GdkPoint* p1, GdkPoint* p2, GdkPoint* result) {
	GdkPoint _result_ = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint _tmp1_ = {0};
	gint _tmp2_ = 0;
	GdkPoint _tmp3_ = {0};
	gint _tmp4_ = 0;
	GdkPoint _tmp5_ = {0};
	gint _tmp6_ = 0;
	GdkPoint _tmp7_ = {0};
	gint _tmp8_ = 0;
#line 173 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (p1 != NULL);
#line 173 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (p2 != NULL);
#line 174 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_.x = 0;
#line 174 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_ = _tmp0_;
#line 175 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = *p1;
#line 175 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = _tmp1_.x;
#line 175 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = *p2;
#line 175 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = _tmp3_.x;
#line 175 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_.x = _tmp2_ - _tmp4_;
#line 176 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = *p1;
#line 176 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = _tmp5_.y;
#line 176 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = *p2;
#line 176 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = _tmp7_.y;
#line 176 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_result_.y = _tmp6_ - _tmp8_;
#line 178 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _result_;
#line 178 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 1572 "image.c"
}


void fix_cairo_pixbuf (GdkPixbuf* pixbuf) {
	guchar* gdk_pixels = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	void* _tmp1_ = NULL;
	void* _tmp2_ = NULL;
#line 182 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 183 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = pixbuf;
#line 183 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = gdk_pixbuf_get_pixels (_tmp0_);
#line 183 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = _tmp1_;
#line 183 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	gdk_pixels = _tmp2_;
#line 1591 "image.c"
	{
		gint j = 0;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		j = 0;
#line 1596 "image.c"
		{
			gboolean _tmp3_ = FALSE;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
			_tmp3_ = TRUE;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
			while (TRUE) {
#line 1603 "image.c"
				gboolean _tmp4_ = FALSE;
				gint _tmp6_ = 0;
				GdkPixbuf* _tmp7_ = NULL;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				guchar* p = NULL;
				guchar* _tmp10_ = NULL;
				guchar* end = NULL;
				guchar* _tmp11_ = NULL;
				GdkPixbuf* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				guchar* _tmp27_ = NULL;
				GdkPixbuf* _tmp28_ = NULL;
				gint _tmp29_ = 0;
				gint _tmp30_ = 0;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp4_ = _tmp3_;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				if (!_tmp4_) {
#line 1624 "image.c"
					gint _tmp5_ = 0;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp5_ = j;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					j = _tmp5_ + 1;
#line 1630 "image.c"
				}
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp3_ = FALSE;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp6_ = j;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp7_ = pixbuf;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp8_ = gdk_pixbuf_get_height (_tmp7_);
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp9_ = _tmp8_;
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				if (!(_tmp6_ < _tmp9_)) {
#line 184 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					break;
#line 1646 "image.c"
				}
#line 185 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp10_ = gdk_pixels;
#line 185 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				p = _tmp10_;
#line 186 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp11_ = p;
#line 186 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp12_ = pixbuf;
#line 186 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 186 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp14_ = _tmp13_;
#line 186 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				end = _tmp11_ + (4 * _tmp14_);
#line 188 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				while (TRUE) {
#line 1664 "image.c"
					guchar* _tmp15_ = NULL;
					guchar* _tmp16_ = NULL;
					guchar tmp = '\0';
					guchar* _tmp17_ = NULL;
					guchar _tmp18_ = '\0';
					guchar* _tmp19_ = NULL;
					guchar* _tmp20_ = NULL;
					guchar _tmp21_ = '\0';
					guchar _tmp22_ = '\0';
					guchar* _tmp23_ = NULL;
					guchar _tmp24_ = '\0';
					guchar _tmp25_ = '\0';
					guchar* _tmp26_ = NULL;
#line 188 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp15_ = p;
#line 188 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp16_ = end;
#line 188 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					if (!(_tmp15_ < _tmp16_)) {
#line 188 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
						break;
#line 1686 "image.c"
					}
#line 189 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp17_ = p;
#line 189 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp18_ = _tmp17_[0];
#line 189 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					tmp = _tmp18_;
#line 191 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp19_ = p;
#line 191 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp20_ = p;
#line 191 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp21_ = _tmp20_[2];
#line 191 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp19_[0] = _tmp21_;
#line 191 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp22_ = _tmp19_[0];
#line 192 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp23_ = p;
#line 192 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp24_ = tmp;
#line 192 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp23_[2] = _tmp24_;
#line 192 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp25_ = _tmp23_[2];
#line 199 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					_tmp26_ = p;
#line 199 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
					p = _tmp26_ + 4;
#line 1716 "image.c"
				}
#line 202 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp27_ = gdk_pixels;
#line 202 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp28_ = pixbuf;
#line 202 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp29_ = gdk_pixbuf_get_rowstride (_tmp28_);
#line 202 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				_tmp30_ = _tmp29_;
#line 202 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
				gdk_pixels = _tmp27_ + _tmp30_;
#line 1728 "image.c"
			}
		}
	}
}


/**
 * Finds the size of the smallest axially-aligned rectangle that could contain
 * a rectangle src_width by src_height, rotated by angle.
 *
 * @param src_width The width of the incoming rectangle.
 * @param src_height The height of the incoming rectangle.
 * @param angle The amount to rotate by, given in degrees.
 * @param dest_width The width of the computed rectangle.
 * @param dest_height The height of the computed rectangle.
 */
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height) {
	gdouble _vala_dest_width = 0.0;
	gdouble _vala_dest_height = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
#line 219 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = angle;
#line 219 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = degrees_to_radians (_tmp0_);
#line 219 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = fabs (_tmp1_);
#line 219 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	angle = _tmp2_;
#line 220 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = angle;
#line 220 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_assert (_tmp3_ <= G_PI_2, "angle <= Math.PI_2");
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = src_width;
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = angle;
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = cos (_tmp5_);
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = src_height;
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = angle;
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = sin (_tmp8_);
#line 221 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_dest_width = (_tmp4_ * _tmp6_) + (_tmp7_ * _tmp9_);
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp10_ = src_height;
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = angle;
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp12_ = cos (_tmp11_);
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_ = src_width;
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp14_ = angle;
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = sin (_tmp14_);
#line 222 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_vala_dest_height = (_tmp10_ * _tmp12_) + (_tmp13_ * _tmp15_);
#line 216 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (dest_width) {
#line 216 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		*dest_width = _vala_dest_width;
#line 1808 "image.c"
	}
#line 216 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (dest_height) {
#line 216 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		*dest_height = _vala_dest_height;
#line 1814 "image.c"
	}
}


/**
 * @brief Rotates a pixbuf to an arbitrary angle, given in degrees, and returns the rotated pixbuf.
 *
 * @param source_pixbuf The source image that needs to be angled.
 * @param angle The angle the source image should be rotated by.
 */
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle) {
	GdkPixbuf* result = NULL;
	gdouble _tmp0_ = 0.0;
	gdouble x_tmp = 0.0;
	gdouble y_tmp = 0.0;
	GdkPixbuf* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GdkPixbuf* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	GdkPixbuf* dest_pixbuf = NULL;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	GdkPixbuf* _tmp16_ = NULL;
	cairo_format_t _tmp17_ = 0;
	GdkPixbuf* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	cairo_surface_t* surface = NULL;
	GdkPixbuf* _tmp21_ = NULL;
	void* _tmp22_ = NULL;
	void* _tmp23_ = NULL;
	cairo_format_t _tmp24_ = 0;
	GdkPixbuf* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	GdkPixbuf* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	GdkPixbuf* _tmp31_ = NULL;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	cairo_surface_t* _tmp34_ = NULL;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp35_ = NULL;
	cairo_t* _tmp36_ = NULL;
	cairo_t* _tmp37_ = NULL;
	cairo_t* _tmp38_ = NULL;
	GdkPixbuf* _tmp39_ = NULL;
	gint _tmp40_ = 0;
	gint _tmp41_ = 0;
	GdkPixbuf* _tmp42_ = NULL;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	cairo_t* _tmp45_ = NULL;
	cairo_t* _tmp46_ = NULL;
	GdkPixbuf* _tmp47_ = NULL;
	gint _tmp48_ = 0;
	gint _tmp49_ = 0;
	GdkPixbuf* _tmp50_ = NULL;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	cairo_t* _tmp53_ = NULL;
	gdouble _tmp54_ = 0.0;
	gdouble _tmp55_ = 0.0;
	cairo_t* _tmp56_ = NULL;
	GdkPixbuf* _tmp57_ = NULL;
	gint _tmp58_ = 0;
	gint _tmp59_ = 0;
	GdkPixbuf* _tmp60_ = NULL;
	gint _tmp61_ = 0;
	gint _tmp62_ = 0;
	cairo_t* _tmp63_ = NULL;
	GdkPixbuf* _tmp64_ = NULL;
	cairo_t* _tmp65_ = NULL;
	cairo_pattern_t* _tmp66_ = NULL;
	cairo_t* _tmp67_ = NULL;
	GdkPixbuf* _tmp68_ = NULL;
#line 231 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (source_pixbuf), NULL);
#line 235 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = angle;
#line 235 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp0_ == 0.0) {
#line 1905 "image.c"
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_ = NULL;
#line 236 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp1_ = source_pixbuf;
#line 236 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 236 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		result = _tmp2_;
#line 236 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		return result;
#line 1916 "image.c"
	}
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = source_pixbuf;
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = gdk_pixbuf_get_width (_tmp3_);
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = _tmp4_;
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = source_pixbuf;
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = gdk_pixbuf_get_height (_tmp6_);
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = _tmp7_;
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = angle;
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	compute_arb_rotated_size ((gdouble) _tmp5_, (gdouble) _tmp8_, _tmp9_, &_tmp10_, &_tmp11_);
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	x_tmp = _tmp10_;
#line 243 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	y_tmp = _tmp11_;
#line 246 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp12_ = x_tmp;
#line 246 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_ = round (_tmp12_);
#line 246 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp14_ = y_tmp;
#line 246 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = round (_tmp14_);
#line 246 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, (gint) _tmp13_, (gint) _tmp15_);
#line 246 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dest_pixbuf = _tmp16_;
#line 251 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = source_pixbuf;
#line 251 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = gdk_pixbuf_get_has_alpha (_tmp18_);
#line 251 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = _tmp19_;
#line 251 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp20_) {
#line 251 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp17_ = CAIRO_FORMAT_ARGB32;
#line 1960 "image.c"
	} else {
#line 251 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp17_ = CAIRO_FORMAT_RGB24;
#line 1964 "image.c"
	}
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = dest_pixbuf;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp22_ = gdk_pixbuf_get_pixels (_tmp21_);
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp23_ = _tmp22_;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp24_ = _tmp17_;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp25_ = dest_pixbuf;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp26_ = gdk_pixbuf_get_width (_tmp25_);
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp27_ = _tmp26_;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp28_ = dest_pixbuf;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp29_ = gdk_pixbuf_get_height (_tmp28_);
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp30_ = _tmp29_;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp31_ = dest_pixbuf;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp32_ = gdk_pixbuf_get_rowstride (_tmp31_);
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp33_ = _tmp32_;
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp34_ = cairo_image_surface_create_for_data ((guchar*) _tmp23_, _tmp24_, _tmp27_, _tmp30_, _tmp33_);
#line 249 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	surface = _tmp34_;
#line 254 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp35_ = surface;
#line 254 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp36_ = cairo_create (_tmp35_);
#line 254 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	context = _tmp36_;
#line 256 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp37_ = context;
#line 256 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_set_source_rgb (_tmp37_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp38_ = context;
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp39_ = dest_pixbuf;
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp40_ = gdk_pixbuf_get_width (_tmp39_);
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp41_ = _tmp40_;
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp42_ = dest_pixbuf;
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp43_ = gdk_pixbuf_get_height (_tmp42_);
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp44_ = _tmp43_;
#line 257 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_rectangle (_tmp38_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp41_, (gdouble) _tmp44_);
#line 258 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp45_ = context;
#line 258 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_fill (_tmp45_);
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp46_ = context;
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp47_ = dest_pixbuf;
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp48_ = gdk_pixbuf_get_width (_tmp47_);
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp49_ = _tmp48_;
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp50_ = dest_pixbuf;
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp51_ = gdk_pixbuf_get_height (_tmp50_);
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp52_ = _tmp51_;
#line 260 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_translate (_tmp46_, (gdouble) (_tmp49_ / 2), (gdouble) (_tmp52_ / 2));
#line 261 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp53_ = context;
#line 261 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp54_ = angle;
#line 261 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp55_ = degrees_to_radians (_tmp54_);
#line 261 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_rotate (_tmp53_, _tmp55_);
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp56_ = context;
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp57_ = source_pixbuf;
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp58_ = gdk_pixbuf_get_width (_tmp57_);
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp59_ = _tmp58_;
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp60_ = source_pixbuf;
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp61_ = gdk_pixbuf_get_height (_tmp60_);
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp62_ = _tmp61_;
#line 262 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_translate (_tmp56_, (gdouble) ((-_tmp59_) / 2), (gdouble) ((-_tmp62_) / 2));
#line 264 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp63_ = context;
#line 264 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp64_ = source_pixbuf;
#line 264 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	gdk_cairo_set_source_pixbuf (_tmp63_, _tmp64_, (gdouble) 0, (gdouble) 0);
#line 265 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp65_ = context;
#line 265 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp66_ = cairo_get_source (_tmp65_);
#line 265 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_pattern_set_filter (_tmp66_, CAIRO_FILTER_BEST);
#line 266 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp67_ = context;
#line 266 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_paint (_tmp67_);
#line 270 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp68_ = dest_pixbuf;
#line 270 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	fix_cairo_pixbuf (_tmp68_);
#line 272 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	result = dest_pixbuf;
#line 272 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_cairo_destroy0 (context);
#line 272 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_cairo_surface_destroy0 (surface);
#line 272 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return result;
#line 2094 "image.c"
}


/**
 * @brief Rotates a point around the upper left corner of an image to an arbitrary angle,
 * given in degrees, and returns the rotated point, translated such that it, along with its attendant
 * image, are in positive x, positive y.
 *
 * @note May be subject to slight inaccuracy as Gdk points' coordinates may only be in whole pixels,
 * so the fractional component is lost.
 *
 * @param source_point The point to be rotated and scaled.
 * @param img_w The width of the source image (unrotated).
 * @param img_h The height of the source image (unrotated).
 * @param angle The angle the source image is to be rotated by to straighten it.
 */
void rotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, gboolean invert, GdkPoint* result) {
	gdouble _tmp0_ = 0.0;
	gdouble dest_width = 0.0;
	gdouble dest_height = 0.0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	cairo_matrix_t matrix = {0};
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gboolean _tmp13_ = FALSE;
	gdouble dest_x = 0.0;
	GdkPoint _tmp15_ = {0};
	gint _tmp16_ = 0;
	gdouble dest_y = 0.0;
	GdkPoint _tmp17_ = {0};
	gint _tmp18_ = 0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	GdkPoint _tmp21_ = {0};
#line 288 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (source_point != NULL);
#line 291 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = angle;
#line 291 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp0_ == 0.0) {
#line 2143 "image.c"
		GdkPoint _tmp1_ = {0};
#line 293 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp1_ = *source_point;
#line 293 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		*result = _tmp1_;
#line 293 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		return;
#line 2151 "image.c"
	}
#line 298 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = img_w;
#line 298 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = img_h;
#line 298 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_ = angle;
#line 298 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	compute_arb_rotated_size ((gdouble) _tmp2_, (gdouble) _tmp3_, _tmp4_, &_tmp5_, &_tmp6_);
#line 298 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dest_width = _tmp5_;
#line 298 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dest_height = _tmp6_;
#line 300 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_matrix_init_identity (&matrix);
#line 301 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = dest_width;
#line 301 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp8_ = dest_height;
#line 301 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_matrix_translate (&matrix, _tmp7_ / 2, _tmp8_ / 2);
#line 302 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = angle;
#line 302 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp10_ = degrees_to_radians (_tmp9_);
#line 302 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_matrix_rotate (&matrix, _tmp10_);
#line 303 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = img_w;
#line 303 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp12_ = img_h;
#line 303 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_matrix_translate (&matrix, (gdouble) ((-_tmp11_) / 2), (gdouble) ((-_tmp12_) / 2));
#line 304 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_ = invert;
#line 304 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp13_) {
#line 2189 "image.c"
		cairo_status_t _tmp14_ = 0;
#line 305 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp14_ = cairo_matrix_invert (&matrix);
#line 305 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_vala_assert (_tmp14_ == CAIRO_STATUS_SUCCESS, "matrix.invert() == Cairo.Status.SUCCESS");
#line 2195 "image.c"
	}
#line 307 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = *source_point;
#line 307 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = _tmp15_.x;
#line 307 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dest_x = (gdouble) _tmp16_;
#line 308 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp17_ = *source_point;
#line 308 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = _tmp17_.y;
#line 308 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	dest_y = (gdouble) _tmp18_;
#line 309 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	cairo_matrix_transform_point (&matrix, &dest_x, &dest_y);
#line 311 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = dest_x;
#line 311 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = dest_y;
#line 311 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_.x = (gint) _tmp19_;
#line 311 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_.y = (gint) _tmp20_;
#line 311 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _tmp21_;
#line 311 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 2223 "image.c"
}


/**
 * @brief <u>De</u>rotates a point around the upper left corner of an image from an arbitrary angle,
 * given in degrees, and returns the de-rotated point, taking into account any translation necessary
 * to make sure all of the rotated image stays in positive x, positive y.
 *
 * @note May be subject to slight inaccuracy as Gdk points' coordinates may only be in whole pixels,
 * so the fractional component is lost.
 *
 * @param source_point The point to be de-rotated.
 * @param img_w The width of the source image (unrotated).
 * @param img_h The height of the source image (unrotated).
 * @param angle The angle the source image is to be rotated by to straighten it.
 */
void derotate_point_arb (GdkPoint* source_point, gint img_w, gint img_h, gdouble angle, GdkPoint* result) {
	GdkPoint _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gdouble _tmp3_ = 0.0;
	GdkPoint _tmp4_ = {0};
#line 327 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (source_point != NULL);
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = *source_point;
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = img_w;
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = img_h;
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = angle;
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	rotate_point_arb (&_tmp0_, _tmp1_, _tmp2_, _tmp3_, TRUE, &_tmp4_);
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _tmp4_;
#line 328 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 2262 "image.c"
}


void clamp_inside_rotated_image (Box* src, gint img_w, gint img_h, gdouble angle_deg, gboolean preserve_geom, Box* result) {
	GdkPoint top_left = {0};
	Box _tmp0_ = {0};
	gint _tmp1_ = 0;
	Box _tmp2_ = {0};
	gint _tmp3_ = 0;
	GdkPoint _tmp4_ = {0};
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gdouble _tmp7_ = 0.0;
	GdkPoint _tmp8_ = {0};
	GdkPoint top_right = {0};
	Box _tmp9_ = {0};
	gint _tmp10_ = 0;
	Box _tmp11_ = {0};
	gint _tmp12_ = 0;
	GdkPoint _tmp13_ = {0};
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gdouble _tmp16_ = 0.0;
	GdkPoint _tmp17_ = {0};
	GdkPoint bottom_left = {0};
	Box _tmp18_ = {0};
	gint _tmp19_ = 0;
	Box _tmp20_ = {0};
	gint _tmp21_ = 0;
	GdkPoint _tmp22_ = {0};
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gdouble _tmp25_ = 0.0;
	GdkPoint _tmp26_ = {0};
	GdkPoint bottom_right = {0};
	Box _tmp27_ = {0};
	gint _tmp28_ = 0;
	Box _tmp29_ = {0};
	gint _tmp30_ = 0;
	GdkPoint _tmp31_ = {0};
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gdouble _tmp34_ = 0.0;
	GdkPoint _tmp35_ = {0};
	gdouble angle = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gint top_offset = 0;
	gint bottom_offset = 0;
	gint left_offset = 0;
	gint right_offset = 0;
	gint top = 0;
	GdkPoint _tmp38_ = {0};
	gint _tmp39_ = 0;
	GdkPoint _tmp40_ = {0};
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint bottom = 0;
	GdkPoint _tmp47_ = {0};
	gint _tmp48_ = 0;
	GdkPoint _tmp49_ = {0};
	gint _tmp50_ = 0;
	gint _tmp51_ = 0;
	gint _tmp52_ = 0;
	gint _tmp53_ = 0;
	gint left = 0;
	GdkPoint _tmp58_ = {0};
	gint _tmp59_ = 0;
	GdkPoint _tmp60_ = {0};
	gint _tmp61_ = 0;
	gint _tmp62_ = 0;
	gint _tmp63_ = 0;
	gint right = 0;
	GdkPoint _tmp67_ = {0};
	gint _tmp68_ = 0;
	GdkPoint _tmp69_ = {0};
	gint _tmp70_ = 0;
	gint _tmp71_ = 0;
	gint _tmp72_ = 0;
	gint _tmp73_ = 0;
	Box _tmp78_ = {0};
	gboolean _tmp79_ = FALSE;
#line 333 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	g_return_if_fail (src != NULL);
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp0_ = *src;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp1_ = _tmp0_.left;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp2_ = *src;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp3_ = _tmp2_.top;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_.x = _tmp1_;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp4_.y = _tmp3_;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp5_ = img_w;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp6_ = img_h;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp7_ = angle_deg;
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	derotate_point_arb (&_tmp4_, _tmp5_, _tmp6_, _tmp7_, &_tmp8_);
#line 336 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	top_left = _tmp8_;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp9_ = *src;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp10_ = _tmp9_.right;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp11_ = *src;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp12_ = _tmp11_.top;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_.x = _tmp10_;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp13_.y = _tmp12_;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp14_ = img_w;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp15_ = img_h;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp16_ = angle_deg;
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	derotate_point_arb (&_tmp13_, _tmp14_, _tmp15_, _tmp16_, &_tmp17_);
#line 337 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	top_right = _tmp17_;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp18_ = *src;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp19_ = _tmp18_.left;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp20_ = *src;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp21_ = _tmp20_.bottom;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp22_.x = _tmp19_;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp22_.y = _tmp21_;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp23_ = img_w;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp24_ = img_h;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp25_ = angle_deg;
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	derotate_point_arb (&_tmp22_, _tmp23_, _tmp24_, _tmp25_, &_tmp26_);
#line 338 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	bottom_left = _tmp26_;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp27_ = *src;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp28_ = _tmp27_.right;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp29_ = *src;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp30_ = _tmp29_.bottom;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp31_.x = _tmp28_;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp31_.y = _tmp30_;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp32_ = img_w;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp33_ = img_h;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp34_ = angle_deg;
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	derotate_point_arb (&_tmp31_, _tmp32_, _tmp33_, _tmp34_, &_tmp35_);
#line 339 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	bottom_right = _tmp35_;
#line 341 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp36_ = angle_deg;
#line 341 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp37_ = degrees_to_radians (_tmp36_);
#line 341 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	angle = _tmp37_;
#line 342 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	top_offset = 0;
#line 342 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	bottom_offset = 0;
#line 342 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	left_offset = 0;
#line 342 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	right_offset = 0;
#line 344 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp38_ = top_left;
#line 344 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp39_ = _tmp38_.y;
#line 344 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp40_ = top_right;
#line 344 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp41_ = _tmp40_.y;
#line 344 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp42_ = MIN (_tmp39_, _tmp41_);
#line 344 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	top = _tmp42_;
#line 345 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp43_ = top;
#line 345 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp43_ < 0) {
#line 2466 "image.c"
		gint _tmp44_ = 0;
		gdouble _tmp45_ = 0.0;
		gdouble _tmp46_ = 0.0;
#line 346 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp44_ = top;
#line 346 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp45_ = angle;
#line 346 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp46_ = cos (_tmp45_);
#line 346 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		top_offset = (gint) ((0 - _tmp44_) * _tmp46_);
#line 2478 "image.c"
	}
#line 348 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp47_ = bottom_left;
#line 348 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp48_ = _tmp47_.y;
#line 348 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp49_ = bottom_right;
#line 348 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp50_ = _tmp49_.y;
#line 348 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp51_ = MAX (_tmp48_, _tmp50_);
#line 348 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	bottom = _tmp51_;
#line 349 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp52_ = bottom;
#line 349 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp53_ = img_h;
#line 349 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp52_ > _tmp53_) {
#line 2498 "image.c"
		gint _tmp54_ = 0;
		gint _tmp55_ = 0;
		gdouble _tmp56_ = 0.0;
		gdouble _tmp57_ = 0.0;
#line 350 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp54_ = img_h;
#line 350 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp55_ = bottom;
#line 350 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp56_ = angle;
#line 350 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp57_ = cos (_tmp56_);
#line 350 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		bottom_offset = (gint) ((_tmp54_ - _tmp55_) * _tmp57_);
#line 2513 "image.c"
	}
#line 352 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp58_ = top_left;
#line 352 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp59_ = _tmp58_.x;
#line 352 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp60_ = bottom_left;
#line 352 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp61_ = _tmp60_.x;
#line 352 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp62_ = MIN (_tmp59_, _tmp61_);
#line 352 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	left = _tmp62_;
#line 353 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp63_ = left;
#line 353 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp63_ < 0) {
#line 2531 "image.c"
		gint _tmp64_ = 0;
		gdouble _tmp65_ = 0.0;
		gdouble _tmp66_ = 0.0;
#line 354 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp64_ = left;
#line 354 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp65_ = angle;
#line 354 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp66_ = cos (_tmp65_);
#line 354 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		left_offset = (gint) ((0 - _tmp64_) * _tmp66_);
#line 2543 "image.c"
	}
#line 356 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp67_ = top_right;
#line 356 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp68_ = _tmp67_.x;
#line 356 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp69_ = bottom_right;
#line 356 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp70_ = _tmp69_.x;
#line 356 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp71_ = MAX (_tmp68_, _tmp70_);
#line 356 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	right = _tmp71_;
#line 357 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp72_ = right;
#line 357 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp73_ = img_w;
#line 357 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp72_ > _tmp73_) {
#line 2563 "image.c"
		gint _tmp74_ = 0;
		gint _tmp75_ = 0;
		gdouble _tmp76_ = 0.0;
		gdouble _tmp77_ = 0.0;
#line 358 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp74_ = img_w;
#line 358 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp75_ = right;
#line 358 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp76_ = angle;
#line 358 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp77_ = cos (_tmp76_);
#line 358 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		right_offset = (gint) ((_tmp74_ - _tmp75_) * _tmp77_);
#line 2578 "image.c"
	}
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	_tmp79_ = preserve_geom;
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	if (_tmp79_) {
#line 2584 "image.c"
		gint _tmp80_ = 0;
		gint _tmp81_ = 0;
		gint _tmp82_ = 0;
		gint _tmp83_ = 0;
		Box _tmp84_ = {0};
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp80_ = left_offset;
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp81_ = right_offset;
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp82_ = top_offset;
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp83_ = bottom_offset;
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		box_get_offset (src, _tmp80_ + _tmp81_, _tmp82_ + _tmp83_, &_tmp84_);
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp78_ = _tmp84_;
#line 2602 "image.c"
	} else {
		Box _tmp85_ = {0};
		gint _tmp86_ = 0;
		gint _tmp87_ = 0;
		Box _tmp88_ = {0};
		gint _tmp89_ = 0;
		gint _tmp90_ = 0;
		Box _tmp91_ = {0};
		gint _tmp92_ = 0;
		gint _tmp93_ = 0;
		Box _tmp94_ = {0};
		gint _tmp95_ = 0;
		gint _tmp96_ = 0;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp85_ = *src;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp86_ = _tmp85_.left;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp87_ = left_offset;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp88_ = *src;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp89_ = _tmp88_.top;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp90_ = top_offset;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp91_ = *src;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp92_ = _tmp91_.right;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp93_ = right_offset;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp94_ = *src;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp95_ = _tmp94_.bottom;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		_tmp96_ = bottom_offset;
#line 361 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
		box_init (&_tmp78_, _tmp86_ + _tmp87_, _tmp89_ + _tmp90_, _tmp92_ + _tmp93_, _tmp95_ + _tmp96_);
#line 2642 "image.c"
	}
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	*result = _tmp78_;
#line 360 "/home/iurt/rpmbuild/BUILD/shotwell-0.15.1/src/util/image.vala"
	return;
#line 2648 "image.c"
}



